*trigger
128  
*oned
1..64 adc 65536
256   stat   16384
257 info 65536

*twod

*vars
*sort

#include <stdio.h>
#include <stdlib.h>


int events;
int syncs;
int discw;
int adcs;

int init(void)
 {
  events=0;
   adcs=0;
  syncs=0;
  discw=0;
 return 0;
 }

/*    This procedure is called once for each good event decoded   */
/*     mult contains the number of data items in the event  */
/*    The gid array contains the label (high 16 bits) part of the item word */
/*    The gdata array contains the data (low 16 bits) part of the item word */

int sortin(void)
 {
 int modno, info;
  int chid, chno;
 int infocode, adc, disc, tsL, tsH;
  int group, item;

   if (mult != 1) printf("mult = 0x%x\n", mult);

   if (events < 20)printf("0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x\n",gid[0], gdata[0],gdata[1],gdata[2],gdata[3],gdata[4],gdata[5]);

  events++;


   if (gid[0] == -1) {

//    info data

   modno = gdata[0];
   infocode = gdata[1];

   if (infocode == 6) {

//    FEE64 discriminator data

    discw++;

   disc = (gdata[2] << 16) | gdata[3];
   tsL  = (gdata[4] << 16) | gdata[5];

    inc1d( INFO, disc);

   }
   if (infocode == 4) {

//    SYNC100 timestamp

   syncs++;

   tsH = (gdata[2] << 16) | gdata[3];
   tsL  = (gdata[4] << 16) | gdata[5];

   }

   if (infocode != 6 && infocode != 4) {

     printf ("unexpected info word 0x%x\n", infocode);

   }

   } else {

//    adc data

     adcs++;

    chid = gid[0];
   modno = (chid >> 6) & 63;
    chno = chid & 63;

   adc = gdata[2];
   tsL  = (gdata[3] << 16) | gdata[4];

    item = chno;
    group = modno;

  inc1d( STAT, (group*64)+item);
  inc1d( item+1, adc);

   }
   

 return 0;
 }

int finish(void) 
 {
 printf("\nSorted %d events\n", events);
 printf("%d adc words\n", adcs);
 printf("%d SYNC100 words\n", syncs);
 printf("%d discrimator words\n",discw);
 return 0;
 }

















































































































